--- a/mem-frag-test.c
+++ b/mem-frag-test.c
@@ -96,13 +96,15 @@ static const char *prg_name;
 void write_random_bytes(void *addr, unsigned long len)
 {
 	unsigned long i;
+	const long page_size = sysconf(_SC_PAGESIZE);
+
 	pid_t pid = getpid();
 
 	DPRINTF("%s-%d: %ldmB of memory mapped in the range %lx-%lx \n",
 		prg_name, pid, len >> 20, (unsigned long)addr, (unsigned long)addr + len);
 
 	srand(time(NULL) + pid);
-	for (i = 0; i < len; i++) {
+	for (i = 0; i < len - page_size; i += page_size){
 		char byte = 'A' + (rand() % 26);
 		*((char *)addr + i) = byte;
 	}
